"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
exports.__esModule = true;
var React = require("react");
var Mark_1 = require("./Mark");
var utils_1 = require("./utils");
var Token = function (props) {
    return React.createElement("span", { "data-i": props.i },
        props.content,
        " ");
};
// TODO: When React 16.3 types are ready, remove casts.
var TokenAnnotator = /** @class */ (function (_super) {
    __extends(TokenAnnotator, _super);
    function TokenAnnotator(props) {
        var _this = _super.call(this, props) || this;
        _this.handleMouseUp = function () {
            var _a;
            if (!_this.props.onChange)
                return;
            var selection = window.getSelection();
            if (utils_1.selectionIsEmpty(selection))
                return;
            if (!selection.anchorNode.parentElement.hasAttribute('data-i') ||
                !selection.focusNode.parentElement.hasAttribute('data-i')) {
                window.getSelection().empty();
                return false;
            }
            var start = parseInt(selection.anchorNode.parentElement.getAttribute('data-i'), 10);
            var end = parseInt(selection.focusNode.parentElement.getAttribute('data-i'), 10);
            if (utils_1.selectionIsBackwards(selection)) {
                ;
                _a = [end, start], start = _a[0], end = _a[1];
            }
            end += 1;
            _this.props.onChange(__spreadArrays(_this.props.value, [
                _this.getSpan({ start: start, end: end, tokens: _this.props.tokens.slice(start, end) }),
            ]));
            window.getSelection().empty();
        };
        _this.handleSplitClick = function (_a) {
            var start = _a.start, end = _a.end;
            // Find and remove the matching split.
            var splitIndex = _this.props.value.findIndex(function (s) { return s.start === start && s.end === end; });
            if (splitIndex >= 0) {
                _this.props.onChange(__spreadArrays(_this.props.value.slice(0, splitIndex), _this.props.value.slice(splitIndex + 1)));
            }
        };
        _this.getSpan = function (span) {
            if (_this.props.getSpan)
                return _this.props.getSpan(span);
            return span;
        };
        return _this;
    }
    TokenAnnotator.prototype.render = function () {
        var _this = this;
        var _a = this.props, tokens = _a.tokens, value = _a.value, renderMark = _a.renderMark, onChange = _a.onChange, getSpan = _a.getSpan, divProps = __rest(_a, ["tokens", "value", "renderMark", "onChange", "getSpan"]);
        var splits = utils_1.splitTokensWithOffsets(tokens, value);
        return (React.createElement("div", __assign({ onMouseUp: this.handleMouseUp }, divProps), splits.map(function (split, i) {
            return split.mark ? (renderMark(__assign(__assign({ key: split.start + "-" + split.end }, split), { onClick: _this.handleSplitClick }))) : (React.createElement(Token, __assign({ key: split.i }, split)));
        })));
    };
    TokenAnnotator.defaultProps = {
        renderMark: function (props) { return React.createElement(Mark_1["default"], __assign({}, props)); }
    };
    return TokenAnnotator;
}(React.Component));
exports["default"] = TokenAnnotator;
//# sourceMappingURL=TokenAnnotator.js.map